<html>
<head>
<title>OgreD3D9GpuProgram.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_43d9b0265a5a2fd53bf3892a292ce5e9.html">RenderSystems</a>      </li>
      <li class="navelem"><a class="el" href="dir_c7ffc14721c8bed1493f4f78ca8c7331.html">Direct3D9</a>      </li>
      <li class="navelem"><a class="el" href="dir_1208738e8444befc5f502320df40a1ea.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreD3D9GpuProgram.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreD3D9GpuProgram_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __D3D9GpuProgram_H_</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __D3D9GpuProgram_H_</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="comment">// Precompiler options</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreD3D9Prerequisites_8h.html">OgreD3D9Prerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreGpuProgram_8h.html">OgreGpuProgram.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreD3D9Resource_8h.html">OgreD3D9Resource.h</a>&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">namespace </span>Ogre {
<a name="l00037"></a>00037 
<a name="l00039"></a><a class="code" href="classOgre_1_1D3D9GpuProgram.html">00039</a>     <span class="keyword">class </span><a class="code" href="OgreD3D9Prerequisites_8h.html#a2f097a9b4c2ebfb75896e7d6eec01a1d">_OgreD3D9Export</a> <a class="code" href="classOgre_1_1D3D9GpuProgram.html" title="Direct3D implementation of a few things common to low-level vertex &amp; fragment programs.">D3D9GpuProgram</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1GpuProgram.html" title="Defines a program which runs on the GPU such as a vertex or fragment program.">GpuProgram</a>, <span class="keyword">public</span> <a class="code" href="classOgre_1_1D3D9Resource.html" title="Represents a Direct3D rendering resource.">D3D9Resource</a>
<a name="l00040"></a>00040     {   
<a name="l00041"></a>00041     <span class="keyword">public</span>:
<a name="l00043"></a><a class="code" href="classOgre_1_1D3D9GpuProgram_1_1CmdColumnMajorMatrices.html">00043</a>         <span class="keyword">class </span><a class="code" href="classOgre_1_1D3D9GpuProgram_1_1CmdColumnMajorMatrices.html" title="Command object for setting matrix packing in column-major order.">CmdColumnMajorMatrices</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ParamCommand.html" title="Abstract class which is command object which gets/sets parameters.">ParamCommand</a>
<a name="l00044"></a>00044         {
<a name="l00045"></a>00045         <span class="keyword">public</span>:
<a name="l00046"></a>00046             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> doGet(<span class="keyword">const</span> <span class="keywordtype">void</span>* target) <span class="keyword">const</span>;
<a name="l00047"></a>00047             <span class="keywordtype">void</span> doSet(<span class="keywordtype">void</span>* target, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; val);
<a name="l00048"></a>00048         };
<a name="l00050"></a><a class="code" href="classOgre_1_1D3D9GpuProgram_1_1CmdExternalMicrocode.html">00050</a>         <span class="keyword">class </span><a class="code" href="classOgre_1_1D3D9GpuProgram_1_1CmdExternalMicrocode.html" title="Command object for getting/setting external micro code (void*)">CmdExternalMicrocode</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ParamCommand.html" title="Abstract class which is command object which gets/sets parameters.">ParamCommand</a>
<a name="l00051"></a>00051         {
<a name="l00052"></a>00052         <span class="keyword">public</span>:
<a name="l00053"></a>00053             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> doGet(<span class="keyword">const</span> <span class="keywordtype">void</span>* target) <span class="keyword">const</span>;
<a name="l00054"></a>00054             <span class="keywordtype">void</span> doSet(<span class="keywordtype">void</span>* target, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; val);
<a name="l00055"></a>00055         };
<a name="l00056"></a>00056     <span class="keyword">protected</span>:
<a name="l00057"></a><a class="code" href="classOgre_1_1D3D9GpuProgram.html#a2b28bd14d3f2b8b4e7c02cd68bbf2361">00057</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1D3D9GpuProgram_1_1CmdColumnMajorMatrices.html" title="Command object for setting matrix packing in column-major order.">CmdColumnMajorMatrices</a> <a class="code" href="classOgre_1_1D3D9GpuProgram.html#a2b28bd14d3f2b8b4e7c02cd68bbf2361">msCmdColumnMajorMatrices</a>;
<a name="l00058"></a><a class="code" href="classOgre_1_1D3D9GpuProgram.html#ac25e4bda48bc91d9e409098523733324">00058</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1D3D9GpuProgram_1_1CmdExternalMicrocode.html" title="Command object for getting/setting external micro code (void*)">CmdExternalMicrocode</a> <a class="code" href="classOgre_1_1D3D9GpuProgram.html#ac25e4bda48bc91d9e409098523733324">msCmdExternalMicrocode</a>;
<a name="l00059"></a>00059     <span class="keyword">public</span>:
<a name="l00060"></a>00060         <a class="code" href="classOgre_1_1D3D9GpuProgram.html" title="Direct3D implementation of a few things common to low-level vertex &amp; fragment programs.">D3D9GpuProgram</a>(<a class="code" href="classOgre_1_1ResourceManager.html" title="Defines a generic resource handler.">ResourceManager</a>* creator, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="namespaceOgre.html#aeb9f62c8e6c4239315286c63321722b2">ResourceHandle</a> handle,
<a name="l00061"></a>00061             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; group, <span class="keywordtype">bool</span> isManual, <a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>* loader);
<a name="l00062"></a>00062         ~<a class="code" href="classOgre_1_1D3D9GpuProgram.html" title="Direct3D implementation of a few things common to low-level vertex &amp; fragment programs.">D3D9GpuProgram</a>();
<a name="l00063"></a>00063 
<a name="l00064"></a>00064 
<a name="l00066"></a><a class="code" href="classOgre_1_1D3D9GpuProgram.html#a802ab2a65944ff76a739fd93ca449c96">00066</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D9GpuProgram.html#a802ab2a65944ff76a739fd93ca449c96" title="Sets whether matrix packing in column-major order.">setColumnMajorMatrices</a>(<span class="keywordtype">bool</span> columnMajor) { mColumnMajorMatrices = columnMajor; }
<a name="l00068"></a><a class="code" href="classOgre_1_1D3D9GpuProgram.html#a07595d209d4e9a2283bc8ba47d7863e1">00068</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1D3D9GpuProgram.html#a07595d209d4e9a2283bc8ba47d7863e1" title="Gets whether matrix packed in column-major order.">getColumnMajorMatrices</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mColumnMajorMatrices; }
<a name="l00069"></a>00069 
<a name="l00072"></a>00072         <span class="keywordtype">void</span> setExternalMicrocode(<span class="keyword">const</span> <span class="keywordtype">void</span>* pMicrocode, <span class="keywordtype">size_t</span> size);
<a name="l00077"></a>00077         <span class="keywordtype">void</span> setExternalMicrocode(ID3DXBuffer* pMicrocode);
<a name="l00079"></a>00079         LPD3DXBUFFER getExternalMicrocode(<span class="keywordtype">void</span>);
<a name="l00080"></a>00080     <span class="keyword">protected</span>:
<a name="l00082"></a>00082         <span class="keywordtype">void</span> loadImpl(<span class="keywordtype">void</span>);
<a name="l00084"></a>00084         <span class="keywordtype">void</span> loadImpl(IDirect3DDevice9* d3d9Device);
<a name="l00086"></a>00086         <span class="keywordtype">void</span> unloadImpl(<span class="keywordtype">void</span>);
<a name="l00088"></a>00088         <span class="keywordtype">void</span> loadFromSource(<span class="keywordtype">void</span>);
<a name="l00090"></a>00090         <span class="keywordtype">void</span> loadFromSource(IDirect3DDevice9* d3d9Device);        
<a name="l00092"></a>00092         <span class="keyword">virtual</span> <span class="keywordtype">void</span> loadFromMicrocode(IDirect3DDevice9* d3d9Device, ID3DXBuffer* microcode) = 0;
<a name="l00093"></a>00093 
<a name="l00094"></a>00094 
<a name="l00102"></a>00102         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1SharedPtr.html">GpuProgramParametersSharedPtr</a> createParameters(<span class="keywordtype">void</span>);
<a name="l00103"></a>00103     <span class="keyword">protected</span>:    
<a name="l00104"></a><a class="code" href="classOgre_1_1D3D9GpuProgram.html#a21c7c00fb2918353bed94af8c9de7f90">00104</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1D3D9GpuProgram.html#a21c7c00fb2918353bed94af8c9de7f90">mColumnMajorMatrices</a>;
<a name="l00105"></a><a class="code" href="classOgre_1_1D3D9GpuProgram.html#a55b3cda0f14a6e92cc3fe15e1bc2e1fd">00105</a>         ID3DXBuffer* <a class="code" href="classOgre_1_1D3D9GpuProgram.html#a55b3cda0f14a6e92cc3fe15e1bc2e1fd">mExternalMicrocode</a>;
<a name="l00106"></a>00106 
<a name="l00107"></a>00107         <span class="keywordtype">void</span> getMicrocodeFromCache( IDirect3DDevice9* d3d9Device );
<a name="l00108"></a>00108         <span class="keywordtype">void</span> compileMicrocode( IDirect3DDevice9* d3d9Device );
<a name="l00109"></a>00109     };
<a name="l00110"></a>00110 
<a name="l00112"></a><a class="code" href="classOgre_1_1D3D9GpuVertexProgram.html">00112</a>     <span class="keyword">class </span><a class="code" href="OgreD3D9Prerequisites_8h.html#a2f097a9b4c2ebfb75896e7d6eec01a1d">_OgreD3D9Export</a> <a class="code" href="classOgre_1_1D3D9GpuVertexProgram.html" title="Direct3D implementation of low-level vertex programs.">D3D9GpuVertexProgram</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1D3D9GpuProgram.html" title="Direct3D implementation of a few things common to low-level vertex &amp; fragment programs.">D3D9GpuProgram</a>
<a name="l00113"></a>00113     {  
<a name="l00114"></a>00114     <span class="keyword">public</span>:
<a name="l00115"></a>00115         <a class="code" href="classOgre_1_1D3D9GpuVertexProgram.html" title="Direct3D implementation of low-level vertex programs.">D3D9GpuVertexProgram</a>(<a class="code" href="classOgre_1_1ResourceManager.html" title="Defines a generic resource handler.">ResourceManager</a>* creator, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="namespaceOgre.html#aeb9f62c8e6c4239315286c63321722b2">ResourceHandle</a> handle,
<a name="l00116"></a>00116             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; group, <span class="keywordtype">bool</span> isManual, <a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>* loader);
<a name="l00117"></a>00117         ~<a class="code" href="classOgre_1_1D3D9GpuVertexProgram.html" title="Direct3D implementation of low-level vertex programs.">D3D9GpuVertexProgram</a>();
<a name="l00118"></a>00118         
<a name="l00120"></a>00120         IDirect3DVertexShader9* getVertexShader(<span class="keywordtype">void</span>);
<a name="l00121"></a>00121 
<a name="l00122"></a>00122         <span class="comment">// Called immediately after the Direct3D device has been created.</span>
<a name="l00123"></a>00123         <span class="keyword">virtual</span> <span class="keywordtype">void</span> notifyOnDeviceCreate(IDirect3DDevice9* d3d9Device);
<a name="l00124"></a>00124 
<a name="l00125"></a>00125         <span class="comment">// Called before the Direct3D device is going to be destroyed.</span>
<a name="l00126"></a>00126         <span class="keyword">virtual</span> <span class="keywordtype">void</span> notifyOnDeviceDestroy(IDirect3DDevice9* d3d9Device);
<a name="l00127"></a>00127 
<a name="l00128"></a>00128     <span class="keyword">protected</span>:
<a name="l00130"></a>00130         <span class="keywordtype">void</span> unloadImpl(<span class="keywordtype">void</span>);
<a name="l00131"></a>00131         <span class="keywordtype">void</span> loadFromMicrocode(IDirect3DDevice9* d3d9Device, ID3DXBuffer* microcode);
<a name="l00132"></a>00132 
<a name="l00133"></a>00133     <span class="keyword">protected</span>:
<a name="l00134"></a><a class="code" href="classOgre_1_1D3D9GpuVertexProgram.html#ab411ae2aabda10e734aa075a27a5e4c5">00134</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;IDirect3DDevice9*, IDirect3DVertexShader9*&gt;::type</a>   <a class="code" href="classOgre_1_1D3D9GpuVertexProgram.html#ab411ae2aabda10e734aa075a27a5e4c5">DeviceToVertexShaderMap</a>;
<a name="l00135"></a><a class="code" href="classOgre_1_1D3D9GpuVertexProgram.html#aebdcfbeed900026e17fd9f76789748f3">00135</a>         <span class="keyword">typedef</span> DeviceToVertexShaderMap::iterator                       <a class="code" href="classOgre_1_1D3D9GpuVertexProgram.html#aebdcfbeed900026e17fd9f76789748f3">DeviceToVertexShaderIterator</a>;
<a name="l00136"></a>00136     
<a name="l00137"></a><a class="code" href="classOgre_1_1D3D9GpuVertexProgram.html#a0329eec4b17dc7498003ab605fdaab71">00137</a>         <a class="code" href="classOgre_1_1D3D9GpuVertexProgram.html#ab411ae2aabda10e734aa075a27a5e4c5">DeviceToVertexShaderMap</a>     <a class="code" href="classOgre_1_1D3D9GpuVertexProgram.html#a0329eec4b17dc7498003ab605fdaab71">mMapDeviceToVertexShader</a>;   
<a name="l00138"></a>00138     };
<a name="l00139"></a>00139 
<a name="l00141"></a><a class="code" href="classOgre_1_1D3D9GpuFragmentProgram.html">00141</a>     <span class="keyword">class </span><a class="code" href="OgreD3D9Prerequisites_8h.html#a2f097a9b4c2ebfb75896e7d6eec01a1d">_OgreD3D9Export</a> <a class="code" href="classOgre_1_1D3D9GpuFragmentProgram.html" title="Direct3D implementation of low-level fragment programs.">D3D9GpuFragmentProgram</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1D3D9GpuProgram.html" title="Direct3D implementation of a few things common to low-level vertex &amp; fragment programs.">D3D9GpuProgram</a>
<a name="l00142"></a>00142     {  
<a name="l00143"></a>00143     <span class="keyword">public</span>:
<a name="l00144"></a>00144         <a class="code" href="classOgre_1_1D3D9GpuFragmentProgram.html" title="Direct3D implementation of low-level fragment programs.">D3D9GpuFragmentProgram</a>(<a class="code" href="classOgre_1_1ResourceManager.html" title="Defines a generic resource handler.">ResourceManager</a>* creator, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="namespaceOgre.html#aeb9f62c8e6c4239315286c63321722b2">ResourceHandle</a> handle,
<a name="l00145"></a>00145             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; group, <span class="keywordtype">bool</span> isManual, <a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>* loader);
<a name="l00146"></a>00146         ~<a class="code" href="classOgre_1_1D3D9GpuFragmentProgram.html" title="Direct3D implementation of low-level fragment programs.">D3D9GpuFragmentProgram</a>();
<a name="l00148"></a>00148         IDirect3DPixelShader9* getPixelShader(<span class="keywordtype">void</span>);
<a name="l00149"></a>00149 
<a name="l00150"></a>00150         <span class="comment">// Called immediately after the Direct3D device has been created.</span>
<a name="l00151"></a>00151         <span class="keyword">virtual</span> <span class="keywordtype">void</span> notifyOnDeviceCreate(IDirect3DDevice9* d3d9Device);
<a name="l00152"></a>00152 
<a name="l00153"></a>00153         <span class="comment">// Called before the Direct3D device is going to be destroyed.</span>
<a name="l00154"></a>00154         <span class="keyword">virtual</span> <span class="keywordtype">void</span> notifyOnDeviceDestroy(IDirect3DDevice9* d3d9Device);
<a name="l00155"></a>00155 
<a name="l00156"></a>00156     <span class="keyword">protected</span>:
<a name="l00158"></a>00158         <span class="keywordtype">void</span> unloadImpl(<span class="keywordtype">void</span>);
<a name="l00159"></a>00159         <span class="keywordtype">void</span> loadFromMicrocode(IDirect3DDevice9* d3d9Device, ID3DXBuffer* microcode);
<a name="l00160"></a>00160 
<a name="l00161"></a>00161     <span class="keyword">protected</span>:
<a name="l00162"></a><a class="code" href="classOgre_1_1D3D9GpuFragmentProgram.html#a171480086ae67ccc2a246dcd05be6441">00162</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;IDirect3DDevice9*, IDirect3DPixelShader9*&gt;::type</a>    <a class="code" href="classOgre_1_1D3D9GpuFragmentProgram.html#a171480086ae67ccc2a246dcd05be6441">DeviceToPixelShaderMap</a>;
<a name="l00163"></a><a class="code" href="classOgre_1_1D3D9GpuFragmentProgram.html#ae8b795768802d296ae4439b4849d92f1">00163</a>         <span class="keyword">typedef</span> DeviceToPixelShaderMap::iterator                        <a class="code" href="classOgre_1_1D3D9GpuFragmentProgram.html#ae8b795768802d296ae4439b4849d92f1">DeviceToPixelShaderIterator</a>;
<a name="l00164"></a>00164 
<a name="l00165"></a><a class="code" href="classOgre_1_1D3D9GpuFragmentProgram.html#a95224e5f3dcd88d2d2d49802a8b773f7">00165</a>         <a class="code" href="classOgre_1_1D3D9GpuFragmentProgram.html#a171480086ae67ccc2a246dcd05be6441">DeviceToPixelShaderMap</a>      <a class="code" href="classOgre_1_1D3D9GpuFragmentProgram.html#a95224e5f3dcd88d2d2d49802a8b773f7">mMapDeviceToPixelShader</a>;            
<a name="l00166"></a>00166     };
<a name="l00173"></a><a class="code" href="classOgre_1_1D3D9GpuProgramPtr.html">00173</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1D3D9GpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to D3D9GpuProgramPtr.">D3D9GpuProgramPtr</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;D3D9GpuProgram&gt; 
<a name="l00174"></a>00174     {
<a name="l00175"></a>00175     <span class="keyword">public</span>:
<a name="l00176"></a><a class="code" href="classOgre_1_1D3D9GpuProgramPtr.html#a219e8f77e177509cbea30da0adb06ccb">00176</a>         <a class="code" href="classOgre_1_1D3D9GpuProgramPtr.html#a219e8f77e177509cbea30da0adb06ccb">D3D9GpuProgramPtr</a>() : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1D3D9GpuProgram.html" title="Direct3D implementation of a few things common to low-level vertex &amp; fragment programs.">D3D9GpuProgram</a>&gt;() {}
<a name="l00177"></a><a class="code" href="classOgre_1_1D3D9GpuProgramPtr.html#ac9820e501dc140980df8e318255800c8">00177</a>         <span class="keyword">explicit</span> <a class="code" href="classOgre_1_1D3D9GpuProgramPtr.html#ac9820e501dc140980df8e318255800c8">D3D9GpuProgramPtr</a>(<a class="code" href="classOgre_1_1D3D9GpuProgram.html" title="Direct3D implementation of a few things common to low-level vertex &amp; fragment programs.">D3D9GpuProgram</a>* rep) : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1D3D9GpuProgram.html" title="Direct3D implementation of a few things common to low-level vertex &amp; fragment programs.">D3D9GpuProgram</a>&gt;(rep) {}
<a name="l00178"></a><a class="code" href="classOgre_1_1D3D9GpuProgramPtr.html#ac957be9f3eea03c44223d11ab3951ebd">00178</a>         <a class="code" href="classOgre_1_1D3D9GpuProgramPtr.html#ac957be9f3eea03c44223d11ab3951ebd">D3D9GpuProgramPtr</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1D3D9GpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to D3D9GpuProgramPtr.">D3D9GpuProgramPtr</a>&amp; r) : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1D3D9GpuProgram.html" title="Direct3D implementation of a few things common to low-level vertex &amp; fragment programs.">D3D9GpuProgram</a>&gt;(r) {} 
<a name="l00179"></a><a class="code" href="classOgre_1_1D3D9GpuProgramPtr.html#abb88a1a6f3c78bc231faefa027f3605f">00179</a>         <a class="code" href="classOgre_1_1D3D9GpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to D3D9GpuProgramPtr.">D3D9GpuProgramPtr</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html">ResourcePtr</a>&amp; r) : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1D3D9GpuProgram.html" title="Direct3D implementation of a few things common to low-level vertex &amp; fragment programs.">D3D9GpuProgram</a>&gt;()
<a name="l00180"></a>00180         {
<a name="l00181"></a>00181             <span class="comment">// lock &amp; copy other mutex pointer</span>
<a name="l00182"></a>00182             <a class="code" href="OgrePrerequisites_8h.html#a8a4683cdaf73994ea7ec391c1ba82b60">OGRE_LOCK_MUTEX</a>(*r.OGRE_AUTO_MUTEX_NAME)
<a name="l00183"></a>00183             <a class="code" href="OgrePrerequisites_8h.html#acf02af48b9d015cd2f0c10e22466c73a">OGRE_COPY_AUTO_SHARED_MUTEX</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00184"></a>00184             pRep = <span class="keyword">static_cast&lt;</span><a class="code" href="classOgre_1_1D3D9GpuProgram.html" title="Direct3D implementation of a few things common to low-level vertex &amp; fragment programs.">D3D9GpuProgram</a>*<span class="keyword">&gt;</span>(r.<a class="code" href="classOgre_1_1SharedPtr.html#a15e055008751a7c20bdde38662d5f0a1">getPointer</a>());
<a name="l00185"></a>00185             pUseCount = r.<a class="code" href="classOgre_1_1SharedPtr.html#a21c3410c03ec3a4647c7aaa8e59d535d">useCountPointer</a>();
<a name="l00186"></a>00186             <span class="keywordflow">if</span> (pUseCount)
<a name="l00187"></a>00187             {
<a name="l00188"></a>00188                 ++(*pUseCount);
<a name="l00189"></a>00189             }
<a name="l00190"></a>00190         }
<a name="l00191"></a>00191 
<a name="l00193"></a><a class="code" href="classOgre_1_1D3D9GpuProgramPtr.html#a7731e6c621e976d55eb9d58596a5f7a8">00193</a>         <a class="code" href="classOgre_1_1D3D9GpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to D3D9GpuProgramPtr.">D3D9GpuProgramPtr</a>&amp; operator=(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html">ResourcePtr</a>&amp; r)
<a name="l00194"></a>00194         {
<a name="l00195"></a>00195             <span class="keywordflow">if</span> (pRep == static_cast&lt;D3D9GpuProgram*&gt;(r.<a class="code" href="classOgre_1_1SharedPtr.html#a15e055008751a7c20bdde38662d5f0a1">getPointer</a>()))
<a name="l00196"></a>00196                 <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00197"></a>00197             release();
<a name="l00198"></a>00198             <span class="comment">// lock &amp; copy other mutex pointer</span>
<a name="l00199"></a>00199             <a class="code" href="OgrePrerequisites_8h.html#a8a4683cdaf73994ea7ec391c1ba82b60">OGRE_LOCK_MUTEX</a>(*r.OGRE_AUTO_MUTEX_NAME)
<a name="l00200"></a>00200             <a class="code" href="OgrePrerequisites_8h.html#acf02af48b9d015cd2f0c10e22466c73a">OGRE_COPY_AUTO_SHARED_MUTEX</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00201"></a>00201             pRep = <span class="keyword">static_cast&lt;</span><a class="code" href="classOgre_1_1D3D9GpuProgram.html" title="Direct3D implementation of a few things common to low-level vertex &amp; fragment programs.">D3D9GpuProgram</a>*<span class="keyword">&gt;</span>(r.<a class="code" href="classOgre_1_1SharedPtr.html#a15e055008751a7c20bdde38662d5f0a1">getPointer</a>());
<a name="l00202"></a>00202             pUseCount = r.<a class="code" href="classOgre_1_1SharedPtr.html#a21c3410c03ec3a4647c7aaa8e59d535d">useCountPointer</a>();
<a name="l00203"></a>00203             <span class="keywordflow">if</span> (pUseCount)
<a name="l00204"></a>00204             {
<a name="l00205"></a>00205                 ++(*pUseCount);
<a name="l00206"></a>00206             }
<a name="l00207"></a>00207             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00208"></a>00208         }
<a name="l00209"></a>00209     };
<a name="l00210"></a>00210 
<a name="l00211"></a>00211 }
<a name="l00212"></a>00212 
<a name="l00213"></a>00213 
<a name="l00214"></a>00214 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:49
</p>
</body>
</html>
